/*
   Hokoiri Musume  ver.1.2   Puzzle game

                            Copyright (C) 1996,1997,1998  Masao Shiraishi
                            e-mail:msiro@cs.meiji.ac.jp
*/

#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <unistd.h>

#define BODY_X 480
#define BODY_Y 405
#define FR_X   330
#define FR_Y   405
#define F_X    300
#define F_Y    375
#define KOMA   75
#define BUTTON_WX 125
#define BUTTON_WY 35

#define BUTTON_X  342
#define BUTTON1_Y 35
#define BUTTON2_Y 105
#define BUTTON3_Y 335
#define BUTTON4_Y 175
#define BUTTON5_Y 245

#define FONT16 "-jis-fixed-medium-r-normal--16-*-*-*-*-*-jisx0208.1983-0"
#define FONT   "-*-new century schoolbook-medium-i-*--34-*-*-*-p-*-*-*"

#define SP -1
#define BL 10

enum DIR {UP, DOWN, RIGHT, LEFT};

Display *dp;
Window root, body, frame, field, koma_w[10], button[3];
Window expl_w;
Pixmap frame_pix, koma_pix[4], button_pix[2][3];
GC clearGC, frameGC, lineGC, colGC[3][6], text16GC, endGC, maskGC; 
XColor color, dfn;
Colormap cmap;
Cursor cursor_ptr, cursor_hand;
XFontStruct *fn;
XEvent ev;
XFontStruct *fonts;
unsigned long end_pixel;
int sc, dep;
int org_y;
int org16_x[] = {32,40,48}, org16_y;

#if defined(ANSWER) || defined(ANS_OP)
Window ans_body, ans_frame, ans_field, ans_koma_w[10]; 
Window ans_button, stop_button, exit_button;
Pixmap ans_button_pix[2], start_b_pix[2];
int ans_button_x = 40;
char *ans_button_msg = "";
char *stop_b_msg = "";
char ans_button_state = 0;
char ans_active;
int ans_koma_x[10], ans_koma_y[10];
int ans_times;
int answer_f;

#define TERM 250000         /* ˤưλ(us) */
struct timeval start_t;
struct timeval cur_t;
struct timezone tzone;
int delta;
#endif

char *host = NULL;
int wx = 0, wy = 0;
char *colors[] = {"MediumBlue", "ForestGreen", "firebrick", 
		                       "gold", "brown", "gray"};

int koma_x[10], koma_y[10];

int init_koma_x[10] = {75,0,225,0,225,75,0,75,150,225};
int init_koma_y[10] = {0,0,0,150,150,150,300,225,225,300}; 
char init_board[6][7] = {{BL,BL,BL,BL,BL,BL,BL},{BL,1,1,3,3,6,BL},
			   {BL,0,0,5,7,SP,BL},{BL,0,0,5,8,SP,BL},
			   {BL,2,2,4,4,9,BL},{BL,BL,BL,BL,BL,BL,BL}};
char init_kx[10] = {2,1,4,1,4,2,1,2,3,4};
char init_ky[10] = {1,1,1,3,3,3,5,4,4,5};

#if defined(ANSWER) || defined(ANS_OP)
typedef struct{
  int koma;
  enum DIR dir;
} ANS_DATA;

ANS_DATA ans_data[] = {
{6, RIGHT},{9, LEFT},{3, DOWN},{4, DOWN},{5, LEFT},{8, UP},{8, RIGHT},
{5, RIGHT},{3, UP},{6, LEFT},{9, LEFT},{4, LEFT},{8, DOWN},{5, RIGHT},
{7, UP},{9, UP},{6, RIGHT},{3, DOWN},{7, LEFT},{5, LEFT},{8, UP},
{4, RIGHT},{9, RIGHT},{9, DOWN},{5, DOWN},{7, RIGHT},{8, LEFT},{3, UP},
{4, UP},{6, LEFT},{9, RIGHT},{5, DOWN},{8, DOWN},{8, LEFT},{4, LEFT},
{9, UP},{5, RIGHT},{6, RIGHT},{3, DOWN},{7, LEFT},{8, UP},{6, UP},
{5, LEFT},{9, DOWN},{4, RIGHT},{6, RIGHT},{8, RIGHT},{7, RIGHT},{3, UP},
{5, LEFT},{6, DOWN},{8, DOWN},{7, RIGHT},{3, RIGHT},{1, DOWN},{1, DOWN},
{0, LEFT},{7, UP},{7, UP},{8, UP},{8, UP},{6, UP},{6, UP},
{9, LEFT},{9, UP},{5, RIGHT},{5, RIGHT},{1, DOWN},{3, DOWN},{0, DOWN},
{7, LEFT},{7, LEFT},{8, UP},{8, LEFT},{6, UP},{6, UP},{0, RIGHT},
{1, UP},{1, UP},{3, LEFT},{9, LEFT},{9, DOWN},{0, DOWN},{6, DOWN},
{6, LEFT},{2, LEFT},{4, UP},{4, UP},{0, RIGHT},{6, DOWN},{6, DOWN},
{8, DOWN},{7, RIGHT},{1, UP},{3, UP},{9, LEFT},{6, DOWN},{0, LEFT},
{4, DOWN},{4, DOWN},{2, RIGHT},{7, RIGHT},{8, RIGHT},{1, RIGHT},{3, UP},
{3, UP},{0, LEFT},{8, DOWN},{8, DOWN},{7, DOWN},{7, DOWN},{2, LEFT},
{4, UP},{4, UP},{8, RIGHT},{8, UP},{5, UP},{6, RIGHT},{6, RIGHT},
{9, RIGHT},{9, RIGHT},{0, DOWN},{7, LEFT},{7, LEFT},{8, LEFT},{8, LEFT},
{5, UP},{9, UP},{9, RIGHT},{0, RIGHT}, {10, 0}};
#endif

char *button_msg[] = {"ᤫ", "ͷ", ""};
char b_state[3] = {0,0,0};

char board[6][7];
char kx[10], ky[10];

int mx, my;
int pmx, pmy;
int cx, cy;
int koma;

int tesuu;
int have;
int capt;

main( argc, argv )
int argc;
char *argv[];
{
  get_arg( argc, argv );
  init_x();
  XMapWindow( dp, body );
  XMapSubwindows( dp, body );
  XMapSubwindows( dp, frame );
  XMapSubwindows( dp, field );
  tesuu = 0;
  capt = 0;
  have = 0;
  eventloop();
}

get_arg( argc, argv )
int argc;
char *argv[];
{
  int i, d;

  for( i = 1; i < argc; i++ ){
    if( !strcmp( argv[i], "-display" ) ){
      host = (char *)malloc( strlen(argv[++i]) + 1);
      strcpy( host, argv[i] );
    }else if( !strcmp( argv[i], "-geometry" ) ){
      XParseGeometry( argv[++i], &wx, &wy, &d, &d );
#ifdef ANS_OP
    }else if( !strcmp( argv[i], "-answer" ) ){
	answer_f = 1;
#endif
    }else {
      fprintf( stderr, "usage: xhako [-option ...]\n" );
      fprintf( stderr, "\nwhere option include:\n" );
      fprintf( stderr, "\t-display host:dpy\tXserver to connect\n" );
      fprintf( stderr, "\t-geometry geom\t\twindow position\n" );
#ifdef ANS_OP
      fprintf( stderr, "\t-answer\t\t\tdisplay of answer example\n" );
#endif
      fprintf( stderr, "\t\t\t\t\tPresented by M.Shiraishi\n" );
      exit(1);
    }
  }
#ifdef ANSWER
  answer_f = 1;
#endif
  
}

init_x()
{
  XSizeHints size;
  XWMHints hints;
  XChar2b buf[5];
  unsigned long bpixel;
  unsigned long plane_mask; 
  int i, j, n;
  char *p;

  dp = XOpenDisplay( host );
  sc = DefaultScreen( dp );
  root = RootWindow( dp, sc );
  dep = DefaultDepth( dp, sc );
  cmap = DefaultColormap( dp, sc );
  bpixel = BlackPixel( dp, sc );

  init_koma();

/* window */
  body = XCreateSimpleWindow( dp, root, wx, wy, BODY_X, BODY_Y,
			                                0, bpixel, bpixel );
  frame = XCreateSimpleWindow( dp, body, 0, 0, FR_X, FR_Y,
			                                0, bpixel, bpixel );
  field = XCreateSimpleWindow( dp, frame, 15, 15, F_X, F_Y,
			                                0, bpixel, bpixel );
  koma_w[0] = XCreateSimpleWindow( dp, field, koma_x[0], koma_y[0],
				          KOMA*2, KOMA*2, 0, bpixel, bpixel );
  for( i = 1; i < 5; i++ )
    koma_w[i] = XCreateSimpleWindow( dp, field, koma_x[i], koma_y[i],
				            KOMA, KOMA*2, 0, bpixel, bpixel );
  koma_w[5] = XCreateSimpleWindow( dp, field, koma_x[5], koma_y[5],
				            KOMA*2, KOMA, 0, bpixel, bpixel );
  for( i = 6; i < 10; i++ )
    koma_w[i] = XCreateSimpleWindow( dp, field, koma_x[i], koma_y[i],
				              KOMA, KOMA, 0, bpixel, bpixel );
  button[0] = XCreateSimpleWindow( dp, body, BUTTON_X, BUTTON1_Y,
				      BUTTON_WX, BUTTON_WY, 0, bpixel, bpixel);
  button[1] = XCreateSimpleWindow( dp, body, BUTTON_X, BUTTON2_Y,
				      BUTTON_WX, BUTTON_WY, 0, bpixel, bpixel);
  button[2] = XCreateSimpleWindow( dp, body, BUTTON_X, BUTTON3_Y,
				      BUTTON_WX, BUTTON_WY, 0, bpixel, bpixel);
  expl_w = XCreateSimpleWindow( dp, root, 0, 0, 500, 400, 0, bpixel, bpixel );

#if defined(ANSWER) || defined(ANS_OP)
  if( answer_f ){
    ans_body = XCreateSimpleWindow( dp, root, 0, 0, FR_X, FR_Y + 60,
				                          0, bpixel, bpixel );
    ans_frame = XCreateSimpleWindow( dp, ans_body, 0, 0, FR_X, FR_Y,
				                          0, bpixel, bpixel );
    ans_field = XCreateSimpleWindow( dp, ans_frame, 15, 15, F_X, F_Y,
				                          0, bpixel, bpixel );
    ans_koma_w[0] = XCreateSimpleWindow( dp, ans_field, koma_x[0], koma_y[0],
				           KOMA*2, KOMA*2, 0, bpixel, bpixel );
    for( i = 1; i < 5; i++ )
      ans_koma_w[i] = XCreateSimpleWindow( dp, ans_field,
		       koma_x[i], koma_y[i], KOMA, KOMA*2, 0, bpixel, bpixel );
    ans_koma_w[5] = XCreateSimpleWindow( dp, ans_field, koma_x[5], koma_y[5],
				             KOMA*2, KOMA, 0, bpixel, bpixel );
    for( i = 6; i < 10; i++ )
      ans_koma_w[i] = XCreateSimpleWindow( dp, ans_field,
		       koma_x[i], koma_y[i], KOMA, KOMA, 0, bpixel, bpixel );
    ans_button = XCreateSimpleWindow( dp, body, BUTTON_X, BUTTON4_Y,
				      BUTTON_WX, BUTTON_WY, 0, bpixel, bpixel);
    stop_button = XCreateSimpleWindow( dp, ans_body, 20, 425,
				      BUTTON_WX, BUTTON_WY, 0, bpixel, bpixel);
    exit_button = XCreateSimpleWindow( dp, ans_body, 185, 425,
				      BUTTON_WX, BUTTON_WY, 0, bpixel, bpixel);
  }
#endif

/* pixmap */
  frame_pix = XCreatePixmap( dp, body, FR_X, FR_Y, dep );
  koma_pix[0] = XCreatePixmap( dp, field, KOMA*2, KOMA*2, dep );
  koma_pix[1] = XCreatePixmap( dp, field, KOMA, KOMA*2, dep );
  koma_pix[2] = XCreatePixmap( dp, field, KOMA*2, KOMA, dep );
  koma_pix[3] = XCreatePixmap( dp, field, KOMA, KOMA, dep );

  for( i = 0; i < 2; i++ )
    for( j = 0; j < 3; j++ )
      button_pix[i][j] = XCreatePixmap( dp, body, BUTTON_WX, BUTTON_WY, dep );

#if defined(ANSWER) || defined(ANS_OP)
  if( answer_f ){
    ans_button_pix[0] = XCreatePixmap( dp, body, BUTTON_WX, BUTTON_WY, dep );
    ans_button_pix[1] = XCreatePixmap( dp, body, BUTTON_WX, BUTTON_WY, dep );
    start_b_pix[0] = XCreatePixmap( dp, ans_body, BUTTON_WX, BUTTON_WY, dep );
    start_b_pix[1] = XCreatePixmap( dp, ans_body, BUTTON_WX, BUTTON_WY, dep );
  }
#endif

/* GC */
  clearGC =XCreateGC( dp, body, 0, NULL );
  frameGC = XCreateGC( dp, frame, 0, NULL );
  lineGC = XCreateGC( dp, field, 0, NULL );
  text16GC = XCreateGC( dp, body, 0, NULL );
  endGC = XCreateGC( dp, body, 0, NULL );
  maskGC = XCreateGC( dp, body, 0, NULL );
  XSetForeground( dp, clearGC, bpixel );
  XSetForeground( dp, maskGC, bpixel );
  XSetSubwindowMode( dp, maskGC, IncludeInferiors );
  XAllocColorCells( dp, cmap, False, &plane_mask, 0, &end_pixel, 1 );
  XSetForeground( dp, endGC, end_pixel );
  for( j = 0; j < 3; j++ )
    for( i = 0; i < 6; i++ ){
      colGC[j][i] = XCreateGC( dp, body, 0, NULL );
      XSetLineAttributes( dp, colGC[j][i], 1, LineSolid, CapButt, JoinMiter );
    }
  XSetLineAttributes( dp, lineGC, 5, LineSolid, CapButt, JoinMiter );
  XSetLineAttributes( dp, maskGC, 1, LineSolid, CapButt, JoinMiter );
  for( i = 0; i < 6; i++ ){
    XAllocNamedColor( dp, cmap, colors[i], &color, &dfn );
    XSetForeground( dp, colGC[0][i], color.pixel );
    if( i == 4 ) XSetForeground( dp, lineGC, color.pixel );
    dfn = color;
    if( color.red > 50000 ) color.red = 65535; else color.red += 15000;
    if( color.blue > 50000  ) color.blue = 65535; else color.blue += 15000;
    if( color.green > 50000  ) color.green = 65535; else color.green += 15000;
    color.flags = DoRed | DoGreen | DoBlue;
    XAllocColor( dp, cmap, &color );
    XSetForeground( dp, colGC[1][i], color.pixel );
    color = dfn;
    if( color.red < 15000 ) color.red = 0; else color.red -= 15000;
    if( color.blue < 15000 ) color.blue = 0; else color.blue -= 15000;
    if( color.green < 15000 ) color.green = 0; else color.green -= 15000;
    color.flags = DoRed | DoGreen | DoBlue;
    XAllocColor( dp, cmap, &color );
    XSetForeground( dp, colGC[2][i], color.pixel );
  }
  XSetGraphicsExposures( dp, frameGC, False );
  /* font */
  fonts = XLoadQueryFont( dp, FONT16 );
  if( fonts == NULL ){
    fprintf( stderr, "unable to load font.\n" );
    exit(1);
  }
  XSetFont( dp, text16GC, fonts->fid );
  XSetForeground( dp, text16GC, bpixel );
  org16_y = fonts->ascent;

  fonts = XLoadQueryFont( dp, FONT );
  if( fonts == NULL ){
    fprintf( stderr, "unable to load font.\n" );
    exit(1);
  }
  XSetFont( dp, endGC, fonts->fid );
  org_y = fonts->ascent;

/* draw */
  /* frame */
  XFillRectangle( dp, frame_pix, colGC[0][4], 0, 0, FR_X, FR_Y );
  XFillRectangle( dp, frame_pix, clearGC, 90 ,390, 150, 15);
  for( i = 0; i < 3; i++ ){
    XDrawLine( dp, frame_pix, colGC[1][4], i, i, FR_X-i-1, i );
    XDrawLine( dp, frame_pix, colGC[1][4], i, i, i, FR_Y-i-1 );
    XDrawLine( dp, frame_pix, colGC[1][4], 314+i, 14-i, 314+i, 389+i );
    XDrawLine( dp, frame_pix, colGC[1][4], 314+i, 389+i, 239+i, 389+i );
    XDrawLine( dp, frame_pix, colGC[1][4], 239+i, 389+i,239+i, 404-i );
    XDrawLine( dp, frame_pix, colGC[1][4], 14-i, 389+i, 89-i, 389+i );
    XDrawLine( dp, frame_pix, colGC[2][4], 329-i, i, 329-i, 404-i);
    XDrawLine( dp, frame_pix, colGC[2][4], 239+i, 404-i, 329-i, 404-i );
    XDrawLine( dp, frame_pix, colGC[2][4], i, 404-i, 89-i, 404-i );
    XDrawLine( dp, frame_pix, colGC[2][4], 89-i, 389+i, 89-i, 404-i ); 
    XDrawLine( dp, frame_pix, colGC[2][4], 14-i, 14-i, 14-i, 389+i );
    XDrawLine( dp, frame_pix, colGC[2][4], 14-i, 14-i, 314+i, 14-i );
  }
  /* koma */
  XFillRectangle( dp, koma_pix[0], colGC[0][0], 0, 0, KOMA*2, KOMA*2 );
  for( i = 0; i < 5; i++ ){
    XDrawLine( dp, koma_pix[0], colGC[1][0], i, i, KOMA*2-1-i, i );
    XDrawLine( dp, koma_pix[0], colGC[1][0], i, i, i, KOMA*2-i-1 );
    XDrawLine( dp, koma_pix[0], colGC[2][0],
	      KOMA*2-i-1, i, KOMA*2-i-1, KOMA*2-i-1 );
    XDrawLine( dp, koma_pix[0], colGC[2][0],
	      i, KOMA*2-i-1, KOMA*2-i-1, KOMA*2-i-1 );
  }
  XFillRectangle( dp, koma_pix[1], colGC[0][1], 0, 0, KOMA, KOMA*2 );
  for( i = 0; i < 5; i++ ){
    XDrawLine( dp, koma_pix[1], colGC[1][1], i, i, KOMA-1-i, i );
    XDrawLine( dp, koma_pix[1], colGC[1][1], i, i, i, KOMA*2-i-1 );
    XDrawLine( dp, koma_pix[1], colGC[2][1],
	      KOMA-i-1, i, KOMA-i-1, KOMA*2-i-1 );
    XDrawLine( dp, koma_pix[1], colGC[2][1],
	      i, KOMA*2-i-1, KOMA-i-1, KOMA*2-i-1 );
  }
  XFillRectangle( dp, koma_pix[2], colGC[0][2], 0, 0, KOMA*2, KOMA );
  for( i = 0; i < 5; i++ ){
    XDrawLine( dp, koma_pix[2], colGC[1][2], i, i, KOMA*2-1-i, i );
    XDrawLine( dp, koma_pix[2], colGC[1][2], i, i, i, KOMA-i-1 );
    XDrawLine( dp, koma_pix[2], colGC[2][2],
	      KOMA*2-i-1, i, KOMA*2-i-1, KOMA-i-1 );
    XDrawLine( dp, koma_pix[2], colGC[2][2],
	      i, KOMA-i-1, KOMA*2-i-1, KOMA-i-1 );
  }
  XFillRectangle( dp, koma_pix[3], colGC[0][3], 0, 0, KOMA, KOMA );
  for( i = 0; i < 5; i++ ){
    XDrawLine( dp, koma_pix[3], colGC[1][3], i, i, KOMA-1-i, i );
    XDrawLine( dp, koma_pix[3], colGC[1][3], i, i, i, KOMA-i-1 );
    XDrawLine( dp, koma_pix[3], colGC[2][3], KOMA-i-1, i, KOMA-i-1, KOMA-i-1 );
    XDrawLine( dp, koma_pix[3], colGC[2][3], i, KOMA-i-1, KOMA-i-1, KOMA-i-1 );
  }
  /* button */
  XFillRectangle( dp, button_pix[0][0], colGC[0][5],
		                        0, 0, BUTTON_WX, BUTTON_WY );
  XFillRectangle( dp, button_pix[1][0], colGC[0][5],
		                        0, 0, BUTTON_WX, BUTTON_WY );
  for( i = 0; i < 5; i++ ){
    XDrawLine( dp, button_pix[0][0], colGC[1][5], i, i, BUTTON_WX-1-i, i );
    XDrawLine( dp, button_pix[0][0], colGC[1][5], i, i, i, BUTTON_WY-i-1 );
    XDrawLine( dp, button_pix[0][0], colGC[2][5],
	                      BUTTON_WX-i-1, i, BUTTON_WX-i-1, BUTTON_WY-i-1 );
    XDrawLine( dp, button_pix[0][0], colGC[2][5],
	                      i, BUTTON_WY-i-1, BUTTON_WX-i-1, BUTTON_WY-i-1 );
  }
  for( i = 0; i < 5; i++ ){
    XDrawLine( dp, button_pix[1][0], colGC[2][5], i, i, BUTTON_WX-1-i, i );
    XDrawLine( dp, button_pix[1][0], colGC[2][5], i, i, i, BUTTON_WY-i-1 );
    XDrawLine( dp, button_pix[1][0], colGC[1][5],
	                      BUTTON_WX-i-1, i, BUTTON_WX-i-1, BUTTON_WY-i-1 );
    XDrawLine( dp, button_pix[1][0], colGC[1][5],
	                      i, BUTTON_WY-i-1, BUTTON_WX-i-1, BUTTON_WY-i-1 );
  }
  for( i = 1; i < 3; i++ ){
    XCopyArea( dp, button_pix[0][0], button_pix[0][i], frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
    XCopyArea( dp, button_pix[1][0], button_pix[1][i], frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
  }

#if defined(ANSWER) || defined(ANS_OP)
  if( answer_f ){
    XCopyArea( dp, button_pix[0][0], ans_button_pix[0], frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
    XCopyArea( dp, button_pix[1][0], ans_button_pix[1], frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
    XCopyArea( dp, button_pix[0][0], start_b_pix[0], frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
    XCopyArea( dp, button_pix[1][0], start_b_pix[1], frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
  }
#endif

  for( i = 0; i < 3; i++ ){
    n = 0; p = button_msg[i];
    while( *p != '\0' ){
      buf[n].byte1 = ((unsigned char) *(p++)) & 0x7f;
      buf[n++].byte2 = ((unsigned char) *(p++)) & 0x7f ;
    }
    XDrawString16( dp, button_pix[0][i], text16GC,
		                             org16_x[i]-1, org16_y+8, buf, n );
    XDrawString16( dp, button_pix[1][i], text16GC,
		                            org16_x[i]+1, org16_y+10, buf, n );
  }

#if defined(ANSWER) || defined(ANS_OP)
  if( answer_f ){
    n = 0; p = ans_button_msg;
    while( *p != '\0' ){
      buf[n].byte1 = ((unsigned char) *(p++)) & 0x7f;
      buf[n++].byte2 = ((unsigned char) *(p++)) & 0x7f ;
    }
    XDrawString16( dp, ans_button_pix[0], text16GC,
		                           ans_button_x-1, org16_y+8, buf, n );
    XDrawString16( dp, ans_button_pix[1], text16GC,
		                          ans_button_x+1, org16_y+10, buf, n );
    n = 0; p = stop_b_msg;
    while( *p != '\0' ){
      buf[n].byte1 = ((unsigned char) *(p++)) & 0x7f;
      buf[n++].byte2 = ((unsigned char) *(p++)) & 0x7f ;
    }
    XDrawString16( dp, start_b_pix[0], text16GC, 32-1, org16_y+8, buf, n );
    XDrawString16( dp, start_b_pix[1], text16GC, 32+1, org16_y+10, buf, n );
  }
#endif

  XSetForeground( dp, text16GC, WhitePixel( dp, sc ));

/* event */
  for( i = 0; i < 10; i++ )
    XSelectInput( dp, koma_w[i],
      ExposureMask | ButtonPressMask | Button1MotionMask | ButtonReleaseMask );
  for( i = 0; i < 3; i++ )
    XSelectInput( dp, button[i],
		          ExposureMask | ButtonPressMask | ButtonReleaseMask );
  XSelectInput( dp, body, ExposureMask );
  XSelectInput( dp, field, ExposureMask );
  XSelectInput( dp, frame, ExposureMask );
  XSelectInput( dp, expl_w, ExposureMask | ButtonPressMask );

#if defined(ANSWER) || defined(ANS_OP)
  if( answer_f ){
    for( i = 0; i < 10; i++ )
      XSelectInput( dp, ans_koma_w[i], ExposureMask );
    XSelectInput( dp, ans_body, ExposureMask );
    XSelectInput( dp, ans_field, ExposureMask );
    XSelectInput( dp, ans_frame, ExposureMask );
    XSelectInput( dp, ans_button, ExposureMask | ButtonPressMask );
    XSelectInput( dp, stop_button, ExposureMask | ButtonPressMask );
    XSelectInput( dp, exit_button, ExposureMask | ButtonPressMask );
    XStoreName( dp, ans_body, "Answer" );
  }
#endif

/* WM Hint */
  XStoreName( dp, body, "Hakoiri Musume" );
  size.flags = PMinSize | PMaxSize;
  size.min_width  = BODY_X;
  size.min_height = BODY_Y;
  size.max_width  = BODY_X;
  size.max_height = BODY_Y;
  XSetNormalHints( dp, body, &size );
  XStoreName( dp, expl_w, "Explanation" );

/* misc */
  cursor_ptr  = XCreateFontCursor( dp, XC_left_ptr );
  cursor_hand = XCreateFontCursor( dp, XC_hand2 );
  XDefineCursor( dp, body, cursor_ptr );

  hints.flags = InputHint;
  hints.input = False;
  XSetWMHints( dp, body, &hints );
}

init_koma()
{
  int i, j;

  for( i = 0; i < 10; i++ ){
    koma_x[i] = init_koma_x[i];
    koma_y[i] = init_koma_y[i];
  }
  for( i = 0; i < 6; i++ )
    for( j = 0; j < 7; j++ )
      board[i][j] = init_board[i][j];
  for( i = 0; i < 10; i++ ){
    kx[i] = init_kx[i];
    ky[i] = init_ky[i];
  }
}

init_koma_window()
{
  int i;
  for( i = 0; i < 10; i++ )
    XMoveWindow( dp, koma_w[i], koma_x[i], koma_y[i] );
}

eventloop()
{
  while( True ){
    XNextEvent( dp, &ev );
    if( ev.type == Expose )
      draw( ev );
    if( ev.type == ButtonPress )
      button_press( ev );
    if( ev.type == MotionNotify )
      button_motion( ev );
    if( ev.type == ButtonRelease )
      button_release( ev );
  }
}

draw( ev )
XExposeEvent ev;
{
  int i;

  if( ev.window == body ){
    XFillRectangle( dp, body, clearGC, 0, 0, BODY_X, BODY_Y );
    return;}
  if( ev.window == field ){
    XFillRectangle( dp, field, clearGC, 0, 0, F_X, F_Y );
    return;}    
  if( ev.window == frame ){
    XCopyArea( dp, frame_pix, frame, frameGC, 0, 0, FR_X, FR_Y, 0, 0 );
    return;}
  if( ev.window == koma_w[0] ){
    XCopyArea( dp, koma_pix[0], koma_w[0], frameGC,
	                                         0, 0, KOMA*2, KOMA*2, 0, 0 );
    return;}
  for( i = 1; i < 5; i++ )
    if( ev.window == koma_w[i] ){
      XCopyArea( dp, koma_pix[1], koma_w[i], frameGC,
		                                   0, 0, KOMA, KOMA*2, 0, 0 );
      return;}
  if( ev.window == koma_w[5] ){
    XCopyArea( dp, koma_pix[2], koma_w[5], frameGC, 0, 0, KOMA*2, KOMA, 0, 0 );
    return;}
  for( i = 6; i < 10; i++ )
    if( ev.window == koma_w[i] ){
      XCopyArea( dp, koma_pix[3], koma_w[i], frameGC, 0, 0, KOMA, KOMA, 0, 0 );
      return;}
  for( i = 0; i < 3; i++ )
    if( ev.window == button[i] ){
      XCopyArea( dp, button_pix[b_state[i]][i], button[i], frameGC,
		                            0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
      return;}

#if defined(ANSWER) || defined(ANS_OP)
  if( answer_f ){
    if( ev.window == ans_button ){
      XCopyArea( dp, ans_button_pix[ans_button_state], ans_button, frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
      return;}
  }
#endif

}

button_press( ev )
XButtonEvent ev;
{
  int i;

  if( ev.button != Button1 )
    return;

  if( ev.window == button[0] ){
    b_state[0] = 1;
    XCopyArea( dp, button_pix[1][0], button[0], frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
    XFlush( dp );
    usleep(300000);
    tesuu = 0;
    init_koma();
    init_koma_window();
    return;
  }
  if( ev.window == button[1] ){
    b_state[1] = 1;
    XCopyArea( dp, button_pix[1][1], button[1], frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
    XFlush( dp );
    explain();
    return;
  }
  if( ev.window == button[2] ){
    b_state[2] = 1;
    XCopyArea( dp, button_pix[1][2], button[2], frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
    XFlush( dp );
    usleep(400000);
    XCloseDisplay( dp );
    exit(0);
  }

#if defined(ANSWER) || defined(ANS_OP)
  if( answer_f ){
    if( ev.window == ans_button ){
      ans_button_state = 1;
      XCopyArea( dp, ans_button_pix[1], ans_button, frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
      XFlush( dp );
      ans_active = 0;
      ans_times = 0;
      ans_init_koma();
      ans_init_koma_window();
      answer();
      ans_button_state = 0;
      XCopyArea( dp, ans_button_pix[0], ans_button, frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
      XFlush( dp );    
      return;
    }
  }
#endif
  
  for( i = 0; i < 10; i++ )
    if( ev.window == koma_w[i] )
      break;
  koma = i;
  have = 1;
  capt = 1;
  pmx = ev.x_root;
  pmy = ev.y_root;
  cx = cy = 0;
  XDefineCursor( dp, body, cursor_hand );
}

button_motion( ev )
XMotionEvent ev;
{
  if( capt == 0 )
    return;
  mx = ev.x_root;
  my = ev.y_root;
  cx += pmx - mx;
  cy += pmy - my;
  pmx = mx;
  pmy = my;
  if( cx > COUNT )
    move( LEFT ); 
  else if( cx < -COUNT )
    move( RIGHT );
  else if( cy > COUNT )
    move( UP );
  else if( cy < -COUNT )
    move( DOWN );
}

move( dir )
enum DIR dir;
{
  int l;

  if( have ){
    tesuu++;
    have = 0;
  }
  switch( koma ){
  case 0:
    if( !check_move2( dir ) )
      goto not_move;
    board[kx[0]][ky[0]] = SP;
    board[kx[0]+1][ky[0]] = SP;
    board[kx[0]][ky[0]+1] = SP;
    board[kx[0]+1][ky[0]+1] = SP;
    break;
  case 1: case 2: case 3: case 4:
    switch( dir ){
    case UP: case DOWN:
      if( !check_move( dir ) )
	goto not_move;
      break;
    case LEFT: case RIGHT:
      if( !check_move2( dir ) )
	goto not_move;
    }
    board[kx[koma]][ky[koma]] = SP;
    board[kx[koma]][ky[koma]+1] = SP;
    break;
  case 5:
    switch( dir ){
    case UP: case DOWN:
      if( !check_move2( dir ) )
	goto not_move;
      break;
    case LEFT: case RIGHT:
      if( !check_move( dir ) )
	goto not_move;
    }
    board[kx[5]][ky[5]] = SP;
    board[kx[5]+1][ky[5]] = SP;
    break;
  case 6: case 7: case 8: case 9:
    if( !check_move( dir ) )
      goto not_move;
    board[kx[koma]][ky[koma]] = SP;
  }

  switch( dir ){
  case UP:
    ky[koma] -= 1;
    break;
  case DOWN:
    ky[koma] += 1;
    break;
  case LEFT:
    kx[koma] -= 1;
    break;
  case RIGHT:
    kx[koma] += 1;
  }
  switch( koma ){
  case 0:
    board[kx[0]][ky[0]] = 0;
    board[kx[0]+1][ky[0]] = 0;
    board[kx[0]][ky[0]+1] = 0;
    board[kx[0]+1][ky[0]+1] = 0;
    break;
  case 1: case 2: case 3: case 4:
    board[kx[koma]][ky[koma]] = koma;
    board[kx[koma]][ky[koma]+1] = koma;
    break;
  case 5:
    board[kx[5]][ky[5]] = 5;
    board[kx[5]+1][ky[5]] = 5;
    break;
  case 6: case 7: case 8: case 9:
    board[kx[koma]][ky[koma]] = koma;
  }

  switch( dir ){
  case UP:
    for( l = koma_y[koma]; l > koma_y[koma]-KOMA; l-- ){
      XMoveWindow( dp, koma_w[koma], koma_x[koma], l-1 );
      XSync( dp, False );
    }
    koma_y[koma] = l;
    break;
  case DOWN:
    for( l = koma_y[koma]; l < koma_y[koma]+KOMA; l++ ){
      XMoveWindow( dp, koma_w[koma], koma_x[koma], l+1 );
      XSync( dp, False );
    }
    koma_y[koma] = l;
    break;
  case LEFT:
    for( l = koma_x[koma]; l > koma_x[koma]-KOMA; l-- ){
      XMoveWindow( dp, koma_w[koma], l-1, koma_y[koma] );
      XSync( dp, False );
    }
    koma_x[koma] = l;
    break;
  case RIGHT:
    for( l = koma_x[koma]; l < koma_x[koma]+KOMA; l++ ){
      XMoveWindow( dp, koma_w[koma], l+1, koma_y[koma] );
      XSync( dp, False );
    }
    koma_x[koma] = l;
  }
  usleep(100000);
  if( kx[0] == 2 && ky[0] == 4 ){
    ending();
    tesuu = 0;
  }
  while( XCheckMaskEvent( dp, Button1MotionMask, &ev ) ) ;
 not_move:
  cx = cy = 0;
}

int check_move( dir )
enum DIR dir;
{
  switch( dir ){
  case UP:
    if( board[kx[koma]][ky[koma]-1] == SP )
      return 1;
    break;
  case DOWN:
    switch( koma ){
    case 1: case 2: case 3: case 4:
      if( board[kx[koma]][ky[koma]+2] == SP )
	return 1;
      break;
    default:
      if( board[kx[koma]][ky[koma]+1] == SP )
	return 1;
    }
    break;
  case LEFT:
    if( board[kx[koma]-1][ky[koma]] == SP )
      return 1;
    break;
  case RIGHT:
    switch( koma ){
    case 5:
      if( board[kx[koma]+2][ky[koma]] == SP )
	return 1;
      break;
    default:
      if( board[kx[koma]+1][ky[koma]] == SP )
	return 1;
    }
  }
  return 0;
}

int check_move2( dir )
enum DIR dir;
{
  switch( dir ){
  case UP:
    if( board[kx[koma]][ky[koma]-1] == SP &&
                       board[kx[koma]+1][ky[koma]-1] == SP )
      return 1;
    break;
  case DOWN:
    switch( koma ){
    case 0:
      if( board[kx[koma]][ky[koma]+2] == SP &&
	                 board[kx[koma]+1][ky[koma]+2] == SP )
	return 1;
      break;
    default:
      if( board[kx[koma]][ky[koma]+1] == SP &&
	                 board[kx[koma]+1][ky[koma]+1] == SP )
	return 1;
    }
    break;
  case LEFT:
    if( board[kx[koma]-1][ky[koma]] == SP &&
                         board[kx[koma]-1][ky[koma]+1] == SP )
      return 1;
    break;
  case RIGHT:
    switch( koma ){
    case 0:
      if( board[kx[koma]+2][ky[koma]] == SP &&
	                   board[kx[koma]+2][ky[koma]+1] == SP )
	return 1;
      break;
    default:
      if( board[kx[koma]+1][ky[koma]] == SP &&
	                   board[kx[koma]+1][ky[koma]+1] == SP )
	return 1;
    }
  }
  return 0;
}

button_release( ev )
XButtonEvent ev;
{
  if( ev.button != Button1 )
    return;

  if( ev.window == button[0] ){
    b_state[0] = 0;
    XCopyArea( dp, button_pix[0][0], button[0], frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
    XFlush( dp );
  }
  if( ev.window == button[1] ){
    b_state[1] = 0;
    XCopyArea( dp, button_pix[0][1], button[1], frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
    XFlush( dp );
  }
  if( ev.window == button[2] ){
    b_state[2] = 0;
    XCopyArea( dp, button_pix[0][2], button[2], frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
    XFlush( dp );
  }

  capt = 0;
  XDefineCursor( dp, body, cursor_ptr );
}

explain()
{
  XMapWindow( dp, expl_w );
  while( True ){
    XNextEvent( dp, &ev );
    switch( ev.type ){
    case Expose:
      if( ev.xexpose.window == expl_w )
	draw_explanation();
      else
	draw( ev );
      break;
    case ButtonPress:
      if( ev.xbutton.window == expl_w || ev.xbutton.window == button[1] ){
	XUnmapWindow( dp, expl_w );
	ev.type = ButtonRelease;
	ev.xbutton.window = button[1];
	ev.xbutton.button = Button1;
	XSendEvent( dp, button[1], False, 0, &ev );
	XFlush( dp );
	return;
      }
    }
  }
}

draw_explanation()
{
  int fig1_x = 20, fig1_y = 20;
  int fig2_x = 180, fig2_y = 115;
  int fig3_x = 280, fig3_y = 20;
  int i, n;
  char *p;
  XChar2b buf[25];

  static XPoint points[] = {{0,0},{-30,0},{0,-150},{120,0},{0,150},{-30,0}};
  static char *mesg[] = {"", "", "νޤǻäƤ", 
		     "ϥޥΥܥ򲡤ʤưޤ", "ҥȡ", 
			   "ưݥȤǤģȤư",
			   "ޥΥܥ򲡤Ʋ"};
  static int mesg_x[] = {155, 248, 320, 20,  20,  80,  140};
  static int mesg_y[] = {155, 155, 180, 220, 280, 310, 380};

  XFillRectangle( dp, expl_w, clearGC, 0, 0, 500, 400 );
  points[0].x = fig1_x + 30;
  points[0].y = fig1_y + 150;
  XDrawLines( dp, expl_w, lineGC, points, 6, CoordModePrevious );
  XFillRectangle( dp, expl_w, colGC[0][0], fig1_x + 31, fig1_y + 1, 58, 58 );
  XFillRectangle( dp, expl_w, colGC[0][1], fig1_x + 1, fig1_y + 1, 28, 58 );
  XFillRectangle( dp, expl_w, colGC[0][1], fig1_x + 91, fig1_y + 1, 28, 58 );
  XFillRectangle( dp, expl_w, colGC[0][1], fig1_x + 1, fig1_y + 61, 28, 58 );
  XFillRectangle( dp, expl_w, colGC[0][1], fig1_x + 91, fig1_y + 61, 28, 58 );
  XFillRectangle( dp, expl_w, colGC[0][2], fig1_x + 31, fig1_y + 61, 58, 28 );
  XFillRectangle( dp, expl_w, colGC[0][3], fig1_x + 1, fig1_y + 121, 28, 28 );
  XFillRectangle( dp, expl_w, colGC[0][3], fig1_x + 31, fig1_y + 91, 28, 28 );
  XFillRectangle( dp, expl_w, colGC[0][3], fig1_x + 61, fig1_y + 91, 28, 28 );
  XFillRectangle( dp, expl_w, colGC[0][3], fig1_x + 91, fig1_y + 121, 28, 28 );

  XFillRectangle( dp, expl_w, colGC[0][0], fig2_x, fig2_y, 58, 58 );

  points[0].x = fig3_x + 30;
  points[0].y = fig3_y + 150;
  XDrawLines( dp, expl_w, lineGC, points, 6, CoordModePrevious );
  XFillRectangle( dp, expl_w, colGC[0][0], fig3_x + 31, fig3_y + 91, 58, 58 );

  XFillRectangle( dp, expl_w, colGC[0][3], 40, 300, 28, 28 );

  for( i = 0; i < 7; i++ ){
    n = 0; p = mesg[i];
    while( *p != '\0' ){
      buf[n].byte1 = ((unsigned char) *(p++)) & 0x7f;
      buf[n++].byte2 = ((unsigned char) *(p++)) & 0x7f ;
    }
    XDrawString16( dp, expl_w, text16GC,
		                      mesg_x[i], org16_y+mesg_y[i], buf, n );
  }
}

draw_endmsg()
{
  int n, fx;
  char *p;
  char te[10];
  XChar2b buf[20];
  static char *end_msg1 = "ǲ򤭤ޤ";
  static char *end_msg2 = "ޥΥܥ򲡤Ʋ";

  sprintf( te, "%d", tesuu );
  fx = XTextWidth( fonts, te, strlen(te) );
  XDrawString( dp, body, endGC, 200, org_y+180, te, strlen(te) );
  n = 0; p = end_msg1;
  while( *p != '\0' ){
    buf[n].byte1 = ((unsigned char) *(p++)) & 0x7f;
    buf[n++].byte2 = ((unsigned char) *(p++)) & 0x7f ;
  }
  XDrawString16( dp, body, text16GC, 220+fx, org16_y+195, buf, n );
  n = 0; p = end_msg2;
  while( *p != '\0' ){
    buf[n].byte1 = ((unsigned char) *(p++)) & 0x7f;
    buf[n++].byte2 = ((unsigned char) *(p++)) & 0x7f ;
  }
  XDrawString16( dp, body, text16GC, 140, org16_y+380, buf, n );
}

ending()
{
  int i, fx, max;
  double d;
  static char *end_msg = "CONGRATULATIONS !";

  for( i = 0; i < BODY_Y; i += 2 ){
    XDrawLine( dp, body, maskGC, 0, i, BODY_X, i );
    XDrawLine( dp, body, maskGC, 0, BODY_Y-i, BODY_X, BODY_Y-i );
    XSync( dp, True );
    usleep(10000);
  }
  XSelectInput( dp, body, ExposureMask | ButtonPressMask );
  XUnmapSubwindows( dp, body );
  XSync( dp, True );

  while( XPending( dp ) )
    XNextEvent( dp, &ev );

  fx = XTextWidth( fonts, end_msg, 17 );
  fx = (BODY_X - fx) / 2;
  color.pixel = end_pixel;
  color.red = 0;
  color.green = 0;
  color.blue = 0;
  color.flags = DoRed | DoGreen | DoBlue;
  XStoreColor( dp, cmap, &color );
  XDrawString( dp, body, endGC, fx, org_y+100, end_msg, 17 );
  for( i = 0; i < 65536; i += 256 ){
    color.red = i;
    color.green = i;
    color.blue = i;
    XStoreColor( dp, cmap, &color );
    XFlush( dp );
    usleep(10000);
  }
  draw_endmsg();
  for( i = 65535; i >= 32767; i -= 256 ){
    color.green = i;
    color.blue = i;
    XStoreColor( dp, cmap, &color );
    XSync( dp, False );
    usleep(10000);
  }

  i = 0;
  while( XCheckMaskEvent( dp, ButtonPressMask, &ev ) ) ;
  while(True){
    if( XPending(dp) ){
      XNextEvent( dp, &ev );
      if( ev.type == ButtonPress )
	break;
      if( ev.type == Expose ){
	XFillRectangle( dp, body, clearGC, 0, 0, BODY_X, BODY_Y );
	XDrawString( dp, body, endGC, fx, org_y+100, end_msg, 17 );
	draw_endmsg();
      }
    }
    d = 2.0 * M_PI * i / 255;
    color.red = 65535 * (cos(d)+2)/3;
    color.green = 65535 * (cos(d+2.0*M_PI/3)+2)/3; 
    color.blue = 65535 * (cos(d+4.0*M_PI/3)+2)/3;
    XStoreColor( dp, cmap, &color );
    i = (i +1) % 256;
    XSync(dp, False);
    usleep(10000);
  }
  XFillRectangle( dp, body, clearGC, 0, 150, BODY_X, BODY_Y - 150 );
  max = color.red;
  if( max < color.green )
    max = color.green;
  if( max < color.blue )
    max = color.blue;
  for( i = max; i >= 0; i -= 256 ){
    if( color.red < 256 ) color.red = 0; else color.red -= 256;
    if( color.green < 256 ) color.green = 0; else color.green -= 256;
    if( color.blue < 256 ) color.blue = 0; else color.blue -= 256; 
    XStoreColor( dp, cmap, &color );
    XFlush( dp );
    usleep(10000);
  }

  XSelectInput( dp, body, ExposureMask );
  init_koma();
  init_koma_window();
  XClearWindow( dp, body );
  XMapSubwindows( dp, body );
}

#if defined(ANSWER) || defined(ANS_OP)
answer()
{
  XMapWindow( dp, ans_body );
  XMapSubwindows( dp, ans_body );
  XMapSubwindows( dp, ans_frame );
  XMapSubwindows( dp, ans_field );

  while( True ){
    if( !ans_active )
      XNextEvent( dp, &ev );
    else if( XPending(dp) )
      XNextEvent( dp, &ev );
    else
      goto solution;

    switch( ev.type ){
    case Expose:
      if ( !ans_draw( ev ) ) draw( ev );
      break;
    case ButtonPress:
      if( ev.xbutton.button != Button1 )
	break;
      
      if( ev.xbutton.window == stop_button ){
	ans_active = 1-ans_active;
	XCopyArea( dp, start_b_pix[ans_active], stop_button, frameGC,
		                            0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
	XFlush( dp );
	break;
      }
      if( ev.xbutton.window == exit_button ){
	XCopyArea( dp, button_pix[1][2], exit_button, frameGC,
		                            0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
	XFlush( dp );
	usleep( 300000 );
	goto answer_exit;
      }
      if( ev.xbutton.window == ans_button )
	goto answer_exit;
    }
    continue;

  solution:
    if( ans_data[ans_times].koma != BL ){
      gettimeofday( &start_t, &tzone );
      if(ans_move()){
	gettimeofday( &cur_t, &tzone );
	delta = calc_delta( &start_t, &cur_t );
	delta = TERM - delta;
	if( delta > 1000 )
	  usleep( delta );
      }
    }else{
      ans_active = 0;
      XCopyArea( dp, start_b_pix[0], stop_button, frameGC,
		                            0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
      XFlush( dp );
    }
  }
 answer_exit:
  XUnmapWindow( dp, ans_body );
}

calc_delta( sta, cur )
struct timeval *sta, *cur;
{
  int delta;

  delta = ( cur->tv_sec - sta->tv_sec ) * 1000000;
  delta += cur->tv_usec - sta->tv_usec;
  return delta;
}

ans_draw( ev )
XExposeEvent ev;
{
  int i;

  if( ev.window == ans_body ){
    XFillRectangle( dp, body, clearGC, 0, 0, FR_X, FR_Y + 60 );
    return 1;}
  if( ev.window == ans_frame ){
    XCopyArea( dp, frame_pix, ans_frame, frameGC, 0, 0, FR_X, FR_Y, 0, 0 );
    return 1;}
  if( ev.window == ans_koma_w[0] ){
    XCopyArea( dp, koma_pix[0], ans_koma_w[0], frameGC,
	                                          0, 0, KOMA*2, KOMA*2, 0, 0 );
    return 1;}
  for( i = 1; i < 5; i++ )
    if( ev.window == ans_koma_w[i] ){
      XCopyArea( dp, koma_pix[1], ans_koma_w[i], frameGC,
		                                    0, 0, KOMA, KOMA*2, 0, 0 );
      return 1;}
  if( ev.window == ans_koma_w[5] ){
    XCopyArea( dp, koma_pix[2], ans_koma_w[5], frameGC,
	                                            0, 0, KOMA*2, KOMA, 0, 0 );
    return 1;}
  for( i = 6; i < 10; i++ )
    if( ev.window == ans_koma_w[i] ){
      XCopyArea( dp, koma_pix[3], ans_koma_w[i], frameGC,
		                                      0, 0, KOMA, KOMA, 0, 0 );
      return 1;}
  if( ev.window == stop_button ){
    XCopyArea( dp, start_b_pix[ans_active], stop_button, frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
    return 1;}
  if( ev.window == exit_button ){
    XCopyArea( dp, button_pix[0][2], exit_button, frameGC,
	                                    0, 0, BUTTON_WX, BUTTON_WY, 0, 0 );
    return 1;}
  return 0;
}

ans_init_koma()
{
  int i;

  for( i = 0; i < 10; i++ ){
    ans_koma_x[i] = init_koma_x[i];
    ans_koma_y[i] = init_koma_y[i];
  }
}

ans_init_koma_window()
{
  int i;
  for( i = 0; i < 10; i++ )
    XMoveWindow( dp, ans_koma_w[i], ans_koma_x[i], ans_koma_y[i] );
}

ans_move()
{
  int move_koma, dir, l;

  move_koma = ans_data[ans_times].koma;
  dir = ans_data[ans_times++].dir;
  switch( dir ){
  case UP:
    for( l = ans_koma_y[move_koma]; l > ans_koma_y[move_koma]-KOMA; l-- ){
      XMoveWindow( dp, ans_koma_w[move_koma], ans_koma_x[move_koma], l-1 );
      XSync( dp, False );
    }
    ans_koma_y[move_koma] = l;
    break;
  case DOWN:
    for( l = ans_koma_y[move_koma]; l < ans_koma_y[move_koma]+KOMA; l++ ){
      XMoveWindow( dp, ans_koma_w[move_koma], ans_koma_x[move_koma], l+1 );
      XSync( dp, False );
    }
    ans_koma_y[move_koma] = l;
    break;
  case LEFT:
    for( l = ans_koma_x[move_koma]; l > ans_koma_x[move_koma]-KOMA; l-- ){
      XMoveWindow( dp, ans_koma_w[move_koma], l-1, ans_koma_y[move_koma] );
      XSync( dp, False );
    }
    ans_koma_x[move_koma] = l;
    break;
  case RIGHT:
    for( l = ans_koma_x[move_koma]; l < ans_koma_x[move_koma]+KOMA; l++ ){
      XMoveWindow( dp, ans_koma_w[move_koma], l+1, ans_koma_y[move_koma] );
      XSync( dp, False );
    }
    ans_koma_x[move_koma] = l;
  }
  if( move_koma == ans_data[ans_times].koma && dir == ans_data[ans_times].dir )
    return 0;
  else
    return 1;
}
#endif
